diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/TypeDesignationWorkingsetEditorAction.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/TypeDesignationWorkingsetEditorAction.java
index aa3aae8c..473d7302 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/TypeDesignationWorkingsetEditorAction.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/TypeDesignationWorkingsetEditorAction.java
@@ -9,6 +9,7 @@
 package eu.etaxonomy.cdm.vaadin.event;
 
 import java.util.Stack;
+import java.util.UUID;
 
 import com.vaadin.ui.Component;
 
@@ -28,16 +29,16 @@ public class TypeDesignationWorkingsetEditorAction extends AbstractEditorAction
 
     private TypeDesignationWorkingSetType workingSetType;
 
-    private int registrationId;
+    private UUID registrationUuid;
 
-    private int typifiedNameId;
+    private UUID typifiedNameUuid;
 
     private TypedEntityReference<IdentifiableEntity<?>> baseEntityRef;
 
     /**
      *
      * @param action
-     * @param typeDesignationWorkingsetId
+     * @param baseEntityRef
      * @param workingSetType
      * @param registrationId
      * @param source
@@ -45,12 +46,12 @@ public class TypeDesignationWorkingsetEditorAction extends AbstractEditorAction
      */
     public TypeDesignationWorkingsetEditorAction(EditorActionType action, TypedEntityReference<IdentifiableEntity<?>> baseEntityRef,
             TypeDesignationWorkingSetType workingSetType,
-            int registrationId, int typifiedNameId,
+            UUID registrationUuid, UUID typifiedNameUuid,
             Component source, AbstractView sourceView, Stack<EditorActionContext> context) {
         super(action, null, source, sourceView);
         this.baseEntityRef = baseEntityRef;
-        this.registrationId = registrationId;
-        this.typifiedNameId = typifiedNameId;
+        this.registrationUuid = registrationUuid;
+        this.typifiedNameUuid = typifiedNameUuid;
         this.workingSetType = workingSetType;
         this.context = context;
 
@@ -60,19 +61,19 @@ public class TypeDesignationWorkingsetEditorAction extends AbstractEditorAction
      *
      * @param action
      * @param workingSetType
-     * @param registrationId
+     * @param registrationUuid
      * @param source
      * @param sourceView
      */
     public TypeDesignationWorkingsetEditorAction(EditorActionType action, TypeDesignationWorkingSetType workingSetType,
-            int registrationId, int typifiedNameId,
+            UUID registrationUuid, UUID typifiedNameUuid,
             Component source, AbstractView sourceView) {
         super(action, null, source, sourceView);
         this.workingSetType = workingSetType;
-        this.registrationId = registrationId;
-        this.typifiedNameId = typifiedNameId;
+        this.registrationUuid = registrationUuid;
+        this.typifiedNameUuid = typifiedNameUuid;
         this.context = new Stack<>();
-        this.context.push(new EditorActionContext(new TypedEntityReference<Registration>(Registration.class, registrationId), sourceView));
+        this.context.push(new EditorActionContext(new TypedEntityReference<Registration>(Registration.class, registrationUuid), sourceView));
     }
 
 
@@ -86,14 +87,14 @@ public class TypeDesignationWorkingsetEditorAction extends AbstractEditorAction
     }
 
     /**
-     * @return the registrationId
+     * @return the registrationUuid
      */
-    public int getRegistrationId() {
-        return registrationId;
+    public UUID getRegistrationUuid() {
+        return registrationUuid;
     }
 
-    public Integer getTypeDesignationWorkingsetId(){
-        return getEntityId();
+    public UUID getTypeDesignationWorkingsetUuid(){
+        return getEntityUuid();
     }
 
     /**
@@ -104,10 +105,10 @@ public class TypeDesignationWorkingsetEditorAction extends AbstractEditorAction
     }
 
     /**
-     * @return the typifiedNameId
+     * @return the typifiedNameUuid
      */
-    public int getTypifiedNameId() {
-        return typifiedNameId;
+    public UUID getTypifiedNameUuid() {
+        return typifiedNameUuid;
     }
 
 
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/registration/RegistrationWorkingsetAction.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/registration/RegistrationWorkingsetAction.java
index 4764a642..58052945 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/registration/RegistrationWorkingsetAction.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/registration/RegistrationWorkingsetAction.java
@@ -8,6 +8,8 @@
 */
 package eu.etaxonomy.cdm.vaadin.event.registration;
 
+import java.util.UUID;
+
 /**
  * @author a.kohlbecker
  * @since Mar 3, 2017
@@ -16,16 +18,16 @@ package eu.etaxonomy.cdm.vaadin.event.registration;
 public class RegistrationWorkingsetAction {
 
     private Action action;
-    private Integer citationID = null;
+    private UUID citationUuid = null;
 
     /**
      *
      * @param citationID the id of a {@link Reference} denoting a
      * complete registration working set.
      */
-    public RegistrationWorkingsetAction(int citationID, Action action){
+    public RegistrationWorkingsetAction(UUID citationUuid, Action action){
         this.action = action;
-        this.citationID = citationID;
+        this.citationUuid = citationUuid;
     }
 
     /**
@@ -36,10 +38,10 @@ public class RegistrationWorkingsetAction {
     }
 
     /**
-     * @return the registrationID
+     * @return the citationUuid
      */
-    public Integer getCitationID() {
-        return citationID;
+    public UUID getCitationUuid() {
+        return citationUuid;
     }
 
     public boolean isStart() {
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/model/EntityReference.java b/src/main/java/eu/etaxonomy/cdm/vaadin/model/EntityReference.java
index e375b664..f309bcf1 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/model/EntityReference.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/model/EntityReference.java
@@ -8,19 +8,22 @@
 */
 package eu.etaxonomy.cdm.vaadin.model;
 
+import java.util.UUID;
+
 import org.apache.commons.lang.builder.HashCodeBuilder;
 
 public class EntityReference {
-    int id;
+    UUID uuid;
     String label;
 
-    public EntityReference(int id, String label) {
-        this.id = id;
+    public EntityReference(UUID uuid, String label) {
+        this.uuid = uuid;
         this.label = label;
     }
 
-    public int getId() {
-        return id;
+
+    public UUID getUuid() {
+        return uuid;
     }
 
     public String getLabel() {
@@ -34,7 +37,7 @@ public class EntityReference {
     public int hashCode() {
         return new HashCodeBuilder(17, 31)
                 .append(label)
-                .append(id)
+                .append(uuid)
                 .toHashCode();
     }
 
@@ -45,7 +48,7 @@ public class EntityReference {
     public boolean equals(Object obj) {
         try {
             EntityReference other = (EntityReference) obj;
-            return id == other.id && label.equals(other.label);
+            return uuid.equals(other.uuid) && label.equals(other.label);
 
         } catch (Exception e) {
             return false;
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/model/TypedEntityReference.java b/src/main/java/eu/etaxonomy/cdm/vaadin/model/TypedEntityReference.java
index 5961d646..99fbcaa6 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/model/TypedEntityReference.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/model/TypedEntityReference.java
@@ -8,6 +8,8 @@
 */
 package eu.etaxonomy.cdm.vaadin.model;
 
+import java.util.UUID;
+
 import org.apache.commons.lang.builder.HashCodeBuilder;
 
 /**
@@ -18,16 +20,16 @@ import org.apache.commons.lang.builder.HashCodeBuilder;
 public class TypedEntityReference<T> extends EntityReference {
 
     /**
-     * @param id
+     * @param uuid
      * @param label
      */
-    public TypedEntityReference(Class<T> type, int id, String label) {
-        super(id, label);
+    public TypedEntityReference(Class<T> type, UUID uuid, String label) {
+        super(uuid, label);
         this.type = type;
     }
 
-    public TypedEntityReference(Class<T> type, int id) {
-        super(id, null);
+    public TypedEntityReference(Class<T> type, UUID uuid) {
+        super(uuid, null);
         this.type = type;
     }
 
@@ -55,7 +57,7 @@ public class TypedEntityReference<T> extends EntityReference {
     @Override
     public int hashCode() {
         return new HashCodeBuilder(17, 31)
-                .append(id)
+                .append(uuid)
                 .appendSuper(type.hashCode())
                 .hashCode();
     }
@@ -68,7 +70,7 @@ public class TypedEntityReference<T> extends EntityReference {
     public boolean equals(Object obj) {
         try {
             TypedEntityReference other = (TypedEntityReference) obj;
-            return id == other.id && type.equals(other.type);
+            return uuid.equals(other.uuid) && type.equals(other.type);
 
         } catch (Exception e) {
             return false;
@@ -77,7 +79,7 @@ public class TypedEntityReference<T> extends EntityReference {
 
     @Override
     public String toString(){
-        return type.getSimpleName() + "#" + id;
+        return type.getSimpleName() + "#" + uuid;
 
     }
 
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/model/registration/RegistrationWorkingSet.java b/src/main/java/eu/etaxonomy/cdm/vaadin/model/registration/RegistrationWorkingSet.java
index bb7579cc..d876126f 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/model/registration/RegistrationWorkingSet.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/model/registration/RegistrationWorkingSet.java
@@ -14,6 +14,7 @@ import java.util.HashSet;
 import java.util.List;
 import java.util.Optional;
 import java.util.Set;
+import java.util.UUID;
 
 import org.joda.time.DateTime;
 
@@ -33,7 +34,7 @@ public class RegistrationWorkingSet {
 
     private List<RegistrationDTO> registrationDTOs = new ArrayList<>();
 
-    private Integer citationId = null;
+    private UUID citationUuid = null;
 
     private DateTime created = null;
 
@@ -43,7 +44,7 @@ public class RegistrationWorkingSet {
      * Creates an empty working set
      */
     public RegistrationWorkingSet(Reference citation) {
-        citationId = citation.getId();
+        citationUuid = citation.getUuid();
         this.citationString= citation.getTitleCache();
 
     }
@@ -83,11 +84,11 @@ public class RegistrationWorkingSet {
         }
         for(RegistrationDTO regDto : candidates){
                 Reference citation = publicationUnit(regDto);
-                if(citationId == null){
-                    citationId = citation.getId();
+                if(citationUuid == null){
+                    citationUuid = citation.getUuid();
                     citationString = citation.getTitleCache();
                 } else {
-                    if(citation.getId() != citationId.intValue()){
+                    if(!citation.getUuid().equals(citationUuid)){
                         problems.add("Removing Registration " + regDto.getSummary() + " from set since this refers to a different citationString.");
                         continue;
                     }
@@ -180,15 +181,15 @@ public class RegistrationWorkingSet {
         return registrationDTOs;
     }
 
-    public Optional<RegistrationDTO> getRegistrationDTO(int registrationId) {
-        return registrationDTOs.stream().filter(r -> r.getId() == registrationId).findFirst();
+    public Optional<RegistrationDTO> getRegistrationDTO(UUID registrationUuid) {
+        return registrationDTOs.stream().filter(r -> r.getUuid().equals(registrationUuid) ).findFirst();
     }
 
     /**
      * @return the citationId
      */
-    public Integer getCitationId() {
-        return citationId;
+    public UUID getCitationUuid() {
+        return citationUuid;
     }
 
     /**
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/security/PermissionDebugUtils.java b/src/main/java/eu/etaxonomy/cdm/vaadin/security/PermissionDebugUtils.java
index a96645ed..9a93ec49 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/security/PermissionDebugUtils.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/security/PermissionDebugUtils.java
@@ -10,6 +10,7 @@ package eu.etaxonomy.cdm.vaadin.security;
 
 import java.io.Serializable;
 import java.util.EnumSet;
+import java.util.UUID;
 
 import org.apache.log4j.Logger;
 import org.springframework.context.annotation.Profile;
@@ -65,11 +66,11 @@ public class PermissionDebugUtils implements Serializable {
      }
 
     public static Button addGainPerEntityPermissionButton(AbstractComponentContainer toContainer, Class<? extends CdmBase> cdmType,
-            Integer entitiyId, EnumSet<CRUD> crud, String property){
+            UUID entitiyUuid, EnumSet<CRUD> crud, String property){
 
         PermissionDebugUtils pu = PermissionDebugUtils.fromSession();
         if(pu != null){
-            Button button = pu.gainPerEntityPermissionButton(cdmType, entitiyId, crud, property);
+            Button button = pu.gainPerEntityPermissionButton(cdmType, entitiyUuid, crud, property);
             if(button != null){
                 toContainer.addComponent(button);
             }
@@ -78,10 +79,10 @@ public class PermissionDebugUtils implements Serializable {
         return null;
     }
 
-    public Button gainPerEntityPermissionButton(Class<? extends CdmBase> cdmType, Integer entitiyId, EnumSet<CRUD> crud, String property){
+    public Button gainPerEntityPermissionButton(Class<? extends CdmBase> cdmType, UUID entitiyUuid, EnumSet<CRUD> crud, String property){
 
        Button button = new Button(FontAwesome.BOLT);
-       button.addClickListener(e -> UserHelper.fromSession().createAuthorityFor(UserHelper.fromSession().userName(), cdmType, entitiyId, crud, property));
+       button.addClickListener(e -> UserHelper.fromSession().createAuthorityFor(UserHelper.fromSession().userName(), cdmType, entitiyUuid, crud, property));
        button.addStyleName(ValoTheme.BUTTON_DANGER);
        return button;
 
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/security/UserHelper.java b/src/main/java/eu/etaxonomy/cdm/vaadin/security/UserHelper.java
index c66d5e19..27a9d923 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/security/UserHelper.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/security/UserHelper.java
@@ -9,6 +9,7 @@
 package eu.etaxonomy.cdm.vaadin.security;
 
 import java.util.EnumSet;
+import java.util.UUID;
 
 import com.vaadin.server.VaadinSession;
 
@@ -41,6 +42,8 @@ public interface UserHelper {
 
     boolean userHasPermission(Class<? extends CdmBase> cdmType, Integer entitiyId, Object ... args);
 
+    boolean userHasPermission(Class<? extends CdmBase> cdmType, UUID entitiyUUID, Object ... args);
+
     boolean userHasPermission(Class<? extends CdmBase> cdmType, Object ... args);
 
     boolean userHasPermission(CdmBase entity, Object ... args);
@@ -80,6 +83,20 @@ public interface UserHelper {
      */
     public CdmAuthority createAuthorityFor(String username, Class<? extends CdmBase> cdmType, Integer entitiyId, EnumSet<CRUD> crud, String property);
 
+
+    /**
+    *
+    * @param username
+    * @param cdmType
+    * @param entitiyUuid
+    * @param crud
+    * @param property
+    * @return the newly created CdmAuthority only if a new CdmAuthority has been added to the user otherwise
+    * <code>null</code> in case the operation failed of if the user was already granted with this authority.
+    */
+   public CdmAuthority createAuthorityFor(String username, Class<? extends CdmBase> cdmType, UUID entitiyUuid, EnumSet<CRUD> crud, String property);
+
+
     /**
      * @param cdmType
      * @param entitiyId
@@ -89,6 +106,15 @@ public interface UserHelper {
      */
     public CdmAuthority createAuthorityForCurrentUser(Class<? extends CdmBase> cdmType, Integer entitiyId, EnumSet<CRUD> crud, String property);
 
+    /**
+     * @param cdmType
+     * @param entitiyUuid
+     * @param crud
+     * @return the newly created CdmAuthority only if a new CdmAuthority has been added to the user otherwise
+     * <code>null</code> in case the operation failed of if the user was already granted with this authority.
+     */
+    public CdmAuthority createAuthorityForCurrentUser(Class<? extends CdmBase> cdmType, UUID entitiyUuid, EnumSet<CRUD> crud, String property);
+
     /**
      * @param cdmType
      * @param entitiyId
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/util/converter/TypeDesignationSetManager.java b/src/main/java/eu/etaxonomy/cdm/vaadin/util/converter/TypeDesignationSetManager.java
index 74b41c0b..4340023e 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/util/converter/TypeDesignationSetManager.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/util/converter/TypeDesignationSetManager.java
@@ -112,7 +112,7 @@ public class TypeDesignationSetManager {
      */
     public TypeDesignationSetManager(TaxonName typifiedName) {
         this.typeDesignations = new ArrayList<>();
-        this.typifiedNameRef = new EntityReference(typifiedName.getId(), typifiedName.getTitleCache());
+        this.typifiedNameRef = new EntityReference(typifiedName.getUuid(), typifiedName.getTitleCache());
     }
 
     /**
@@ -155,7 +155,7 @@ public class TypeDesignationSetManager {
             final VersionableEntity baseEntity = baseEntity(td);
             final TypedEntityReference<VersionableEntity> baseEntityReference = makeEntityReference(baseEntity);
 
-            EntityReference typeDesignationEntityReference = new EntityReference(td.getId(), stringify(td));
+            EntityReference typeDesignationEntityReference = new EntityReference(td.getUuid(), stringify(td));
 
             TypeDesignationWorkingSet typedesignationWorkingSet;
             if(!byBaseEntityByTypeStatus.containsKey(baseEntityReference)){
@@ -211,7 +211,7 @@ public class TypeDesignationSetManager {
                 label = ((FieldUnit)baseEntity).getTitleCache();
         }
 
-        TypedEntityReference<VersionableEntity> baseEntityReference = new TypedEntityReference(baseEntity.getClass(), baseEntity.getId(), label);
+        TypedEntityReference<VersionableEntity> baseEntityReference = new TypedEntityReference(baseEntity.getClass(), baseEntity.getUuid(), label);
 
         return baseEntityReference;
     }
@@ -394,7 +394,7 @@ public class TypeDesignationSetManager {
             } else {
                 // compare
                 TaxonName otherTypifiedName = typeDesignation.getTypifiedNames().iterator().next();
-                if(typifiedName.getId() != otherTypifiedName.getId()){
+                if(!typifiedName.getUuid().equals(otherTypifiedName.getUuid())){
                   //TODO instead throw RegistrationValidationException()
                     problems.add("Multiple typifiedName in " + typeDesignation.toString());
                 }
@@ -409,7 +409,7 @@ public class TypeDesignationSetManager {
         if(typifiedName != null){
             // ON SUCCESS -------------------
             this.typifiedName = typifiedName;
-            this.typifiedNameRef = new EntityReference(typifiedName.getId(), typifiedName.getTitleCache());
+            this.typifiedNameRef = new EntityReference(typifiedName.getUuid(), typifiedName.getTitleCache());
 
         }
     }
@@ -446,7 +446,7 @@ public class TypeDesignationSetManager {
      */
     public TypeDesignationBase findTypeDesignation(EntityReference typeDesignationRef) {
         for(TypeDesignationBase td : typeDesignations){
-            if(td.getId() == typeDesignationRef.getId()){
+            if(td.getUuid().equals(typeDesignationRef.getUuid())){
                 return td;
             }
         }
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/NameTypeDesignationPopupEditor.java b/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/NameTypeDesignationPopupEditor.java
index 442fabaa..2cf07d21 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/NameTypeDesignationPopupEditor.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/NameTypeDesignationPopupEditor.java
@@ -145,7 +145,7 @@ public class NameTypeDesignationPopupEditor extends AbstractCdmPopupEditor<NameT
                 getViewEventBus().publish(this,
                     new TaxonNameEditorAction(
                             EditorActionType.EDIT,
-                            typeNameField.getValue().getId(),
+                            typeNameField.getValue().getUuid(),
                             typeNameField,
                             this)
                 );
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/NameTypeDesignationPresenter.java b/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/NameTypeDesignationPresenter.java
index bddff6fa..254ded84 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/NameTypeDesignationPresenter.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/NameTypeDesignationPresenter.java
@@ -12,6 +12,7 @@ import java.util.Arrays;
 import java.util.EnumSet;
 import java.util.HashSet;
 import java.util.List;
+import java.util.UUID;
 
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.context.annotation.Scope;
@@ -71,11 +72,11 @@ public class NameTypeDesignationPresenter
         if(identifier instanceof Integer || identifier == null){
             return super.loadBeanById(identifier);
 //        } else if(identifier instanceof TypedEntityReference && ((TypedEntityReference)identifier).getType().equals(TaxonName.class)) {
-//            typifiedNameInContext = getRepo().getNameService().find(((TypedEntityReference)identifier).getId());
+//            typifiedNameInContext = getRepo().getNameService().find(((TypedEntityReference)identifier).getUuid());
 //            bean = super.loadBeanById(null);
         } else {
             TypeDesignationWorkingsetEditorIdSet idset = (TypeDesignationWorkingsetEditorIdSet)identifier;
-            RegistrationDTO regDTO = registrationWorkingSetService.loadDtoById(idset.registrationId);
+            RegistrationDTO regDTO = registrationWorkingSetService.loadDtoByUuid(idset.registrationUuid);
             typifiedNameInContext = regDTO.getTypifiedName();
             // find the working set
             TypeDesignationWorkingSet typeDesignationWorkingSet = regDTO.getTypeDesignationWorkingSet(idset.baseEntityRef);
@@ -85,8 +86,8 @@ public class NameTypeDesignationPresenter
                 throw new RuntimeException("TypeDesignationWorkingsetEditorIdSet references not a NameTypeDesignation");
             }
             // TypeDesignationWorkingSet for NameTyped only contain one item!!!
-            int nameTypeDesignationId = typeDesignationWorkingSet.getTypeDesignations().get(0).getId();
-            return super.loadBeanById(nameTypeDesignationId);
+            UUID nameTypeDesignationUuid = typeDesignationWorkingSet.getTypeDesignations().get(0).getUuid();
+            return super.loadBeanById(nameTypeDesignationUuid);
         }
     }
 
@@ -95,7 +96,7 @@ public class NameTypeDesignationPresenter
      * {@inheritDoc}
      */
     @Override
-    protected NameTypeDesignation loadCdmEntityById(Integer identifier) {
+    protected NameTypeDesignation loadCdmEntity(UUID uuid) {
         List<String> initStrategy = Arrays.asList(new String []{
                 "$",
                 "typifiedNames.typeDesignations", // important !!
@@ -105,8 +106,8 @@ public class NameTypeDesignationPresenter
         );
 
         NameTypeDesignation typeDesignation;
-        if(identifier != null){
-            typeDesignation = (NameTypeDesignation) getRepo().getNameService().loadTypeDesignation(identifier, initStrategy);
+        if(uuid != null){
+            typeDesignation = (NameTypeDesignation) getRepo().getNameService().loadTypeDesignation(uuid, initStrategy);
         } else {
             if(beanInstantiator != null){
                 typeDesignation = beanInstantiator.createNewBean();
@@ -153,7 +154,7 @@ public class NameTypeDesignationPresenter
      * {@inheritDoc}
      */
     @Override
-    protected void guaranteePerEntityCRUDPermissions(Integer identifier) {
+    protected void guaranteePerEntityCRUDPermissions(UUID identifier) {
         if(crud != null){
             newAuthorityCreated = UserHelper.fromSession().createAuthorityForCurrentUser(NameTypeDesignation.class, identifier, crud, null);
         }
@@ -251,7 +252,7 @@ public class NameTypeDesignationPresenter
         typeNamePopup.grantToCurrentUser(EnumSet.of(CRUD.UPDATE, CRUD.DELETE));
         typeNamePopup.withDeleteButton(true);
         // TODO configure Modes???
-        typeNamePopup.loadInEditor(action.getEntityId());
+        typeNamePopup.loadInEditor(action.getEntityUuid());
 
     }
 
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/SpecimenTypeDesignationWorkingsetEditorPresenter.java b/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/SpecimenTypeDesignationWorkingsetEditorPresenter.java
index 2df6d8f5..c8c3f578 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/SpecimenTypeDesignationWorkingsetEditorPresenter.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/view/name/SpecimenTypeDesignationWorkingsetEditorPresenter.java
@@ -12,6 +12,7 @@ import java.util.Arrays;
 import java.util.EnumSet;
 import java.util.HashSet;
 import java.util.Set;
+import java.util.UUID;
 
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.context.annotation.Scope;
@@ -125,7 +126,7 @@ public class SpecimenTypeDesignationWorkingsetEditorPresenter
             TypeDesignationWorkingsetEditorIdSet idset = (TypeDesignationWorkingsetEditorIdSet)identifier;
 
             if(idset.baseEntityRef != null){
-                workingSetDto = specimenTypeDesignationWorkingSetService.loadDtoByIds(idset.registrationId, idset.baseEntityRef);
+                workingSetDto = specimenTypeDesignationWorkingSetService.load(idset.registrationUuid, idset.baseEntityRef);
                 if(workingSetDto.getFieldUnit() == null){
                     workingSetDto = specimenTypeDesignationWorkingSetService.fixMissingFieldUnit(workingSetDto);
                         // FIXME open Dialog to warn user about adding an empty fieldUnit to the typeDesignations
@@ -137,7 +138,7 @@ public class SpecimenTypeDesignationWorkingsetEditorPresenter
                 rootEntities.add(workingSetDto.getOwner());
             } else {
                 // create a new workingset, for a new fieldunit which is the base for the workingset
-                workingSetDto = specimenTypeDesignationWorkingSetService.create(idset.registrationId, idset.publicationId, idset.typifiedNameId);
+                workingSetDto = specimenTypeDesignationWorkingSetService.create(idset.registrationUuid, idset.publicationUuid, idset.typifiedNameUuid);
                 // need to use load but put see #7214
                 cache.load(workingSetDto.getOwner());
                 rootEntities.add(workingSetDto.getOwner());
@@ -205,7 +206,7 @@ public class SpecimenTypeDesignationWorkingsetEditorPresenter
                 row.collection.addClickListenerAddEntity(e -> doCollectionEditorAdd());
                 row.collection.addClickListenerEditEntity(e -> {
                         if(row.collection.getValue() != null){
-                            doCollectionEditorEdit(row.collection.getValue().getId());
+                            doCollectionEditorEdit(row.collection.getValue().getUuid());
                         }
                     });
 
@@ -222,7 +223,7 @@ public class SpecimenTypeDesignationWorkingsetEditorPresenter
                 row.mediaSpecimenReference.addClickListenerAddEntity(e -> doReferenceEditorAdd());
                 row.mediaSpecimenReference.addClickListenerEditEntity(e -> {
                     if(row.mediaSpecimenReference.getValue() != null){
-                        doReferenceEditorEdit(row.mediaSpecimenReference.getValue().getId());
+                        doReferenceEditorEdit(row.mediaSpecimenReference.getValue().getUuid());
                     }
                 });
 
@@ -312,13 +313,13 @@ public class SpecimenTypeDesignationWorkingsetEditorPresenter
         collectionPopupEditor.loadInEditor(null);
     }
 
-    public void doCollectionEditorEdit(int collectionId) {
+    public void doCollectionEditorEdit(UUID collectionUuid) {
 
         collectionPopupEditor = getNavigationManager().showInPopup(CollectionPopupEditor.class, getView());
 
         collectionPopupEditor.grantToCurrentUser(COLLECTION_EDITOR_CRUD);
         collectionPopupEditor.withDeleteButton(true);
-        collectionPopupEditor.loadInEditor(collectionId);
+        collectionPopupEditor.loadInEditor(collectionUuid);
     }
 
 
@@ -326,7 +327,7 @@ public class SpecimenTypeDesignationWorkingsetEditorPresenter
     public void onCollectionEvent(EntityChangeEvent event){
 
         Collection newCollection = getRepo().getCollectionService().load(
-                event.getEntityId(), Arrays.asList(new String[]{"$.institute"})
+                event.getEntityUuid(), Arrays.asList(new String[]{"$.institute"})
                 );
         cache.load(newCollection);
 
@@ -346,19 +347,19 @@ public class SpecimenTypeDesignationWorkingsetEditorPresenter
         referencePopupEditor.loadInEditor(null);
     }
 
-    public void doReferenceEditorEdit(int referenceId) {
+    public void doReferenceEditorEdit(UUID referenceUuid) {
 
         referencePopupEditor = getNavigationManager().showInPopup(ReferencePopupEditor.class, getView());
         referencePopupEditor.withReferenceTypes(RegistrationUIDefaults.MEDIA_REFERENCE_TYPES);
         referencePopupEditor.grantToCurrentUser(COLLECTION_EDITOR_CRUD);
         referencePopupEditor.withDeleteButton(true);
-        referencePopupEditor.loadInEditor(referenceId);
+        referencePopupEditor.loadInEditor(referenceUuid);
     }
 
     @EventBusListenerMethod(filter = EntityChangeEventFilter.ReferenceFilter.class)
     public void onReferenceEvent(EntityChangeEvent event){
 
-        Reference newRef = getRepo().getReferenceService().load(event.getEntityId(), Arrays.asList(new String[]{"$"}));
+        Reference newRef = getRepo().getReferenceService().load(event.getEntityUuid(), Arrays.asList(new String[]{"$"}));
         cache.load(newRef);
 
         for( CollectionRowItemCollection row : collectionPopuEditorSourceRows) {
